<template>
  <a-drawer
    :mask="false"
    :closable="true"
    :visible="collapsed"
    :maskClosable="true"
    :width="slideWidth"
    :bodyStyle="{ padding: '0px' }"
    @close="drawerClose"
    placement="right"
  >
    <a-spin :spinning="loading" style="height: 100vh; width: 100%; line-height: 100vh;">
      <a-card
        :headStyle="{ 'border-bottom': '0px' }"
        :bodyStyle="{ 'margin-top': '30px', padding: '0px' }"
        v-if="info"
        :key="info.username"
        style="min-height: 100vh;"
      >
        <div class="account-center-avatarHolder">
          <div style="margin-right: 16px;">
            <a-avatar :src="info.picture" :size="72" />
          </div>
          <div>
            <div class="username">
              <ellipsis :length="20" tooltip>
                {{ info.name || "No Name" }}
              </ellipsis>
            </div>
            <div>
              <a @click="edit" href="javacript:;">Edit</a>
            </div>
          </div>
        </div>

        <a-card
          :bordered="false"
          :tabList="tabListNoTitle"
          :activeTabKey="noTitleKey"
          :bodyStyle="{ padding: '4px 0px' }"
          @tabChange="key => handleTabChange(key, 'noTitleKey')"
          style="width:100%"
        >
          <info-page v-if="noTitleKey === 'info'" :info="info" @changed="onChanged" />
          <manage-page v-else-if="noTitleKey === 'manage'" :info="info" />
          <inbox-page v-else-if="noTitleKey === 'inbox'" :info="info" />
        </a-card>
      </a-card>
    </a-spin>
  </a-drawer>
</template>

<script>
import InboxPage from './InboxPage'
import ManagePage from './ManagePage'
import InfoPage from './InfoPage'

export default {
  components: {
    InboxPage,
    ManagePage,
    InfoPage
  },
  props: {
    collapsed: {
      type: Boolean,
      default: false
    },
    slideWidth: {
      type: String,
      default: '350px'
    }
  },
  data () {
    return {
      info: null,
      loading: false,

      tabListNoTitle: [
        {
          key: 'info',
          tab: 'Info'
        },
        {
          key: 'manage',
          tab: 'Manage'
        }
      ],
      noTitleKey: 'info'
    }
  },
  created () {},
  methods: {
    edit () {
      this.$emit('edit', this.info)
    },
    onChanged (e) {
      this.info = null
      this.$emit('onChanged', e)
    },
    handleTabChange (key, type) {
      this[type] = key
    },
    drawerClose () {
      this.$emit('close', false)
    },
    loadInfo (info) {
      // this.noTitleKey = "info"
      this.loading = true
      this.info = null
      setTimeout(() => {
        this.loading = false
        this.info = info
      }, 100)
    }
  }
}
</script>

<style lang="less">
.account-center-avatarHolder {
  display: flex;
  flex-direction: row;
  align-items: center;
  padding: 16px;

  .username {
    color: rgba(0, 0, 0, 0.85);
    font-size: 20px;
    line-height: 28px;
    font-weight: 500;
    margin-bottom: 4px;
  }
}
</style>
